#!/bin/bash

if [ ! -f /etc/X11/trusted ]; then
 exit
fi

CLEAR=
if [ "$1" = "clear" ]; then
CLEAR="1"
fi

# 1. TODO Генерится при сборке Х сервер: пройти по /usr/include/xcb/xparsec_roles.h и собрать переменные:
#    получаем
PROP_R="(0x1<<0)"
CLIPB_R="(0x1<<1)"
SNAP_R="(0x1<<2)"
REPARENT_R="(0x1<<3)"
KBD_R="(0x1<<4)"
MAC_R="(0x1<<5)"
HOST_R="(0x1<<6)"
NESTED_R="(0x1<<7)"
WM_R="($PROP_R|$SNAP_R|$REPARENT_R|$KBD_R|$HOST_R)"
ALL_R="($PROP_R|$SNAP_R|$REPARENT_R|$KBD_R|$HOST_R|$MAC_R|$CLIPB_R)"

replacements=(
  "PROP_R":$PROP_R
  "CLIPB_R":$CLIP_R
  "SNAP_R":$SNAP_R
  "REPARENT_R":$REPARENT_R
  "KBD_R":$KBD_R
  "MAC_R":$MAC_R
  "HOST_R":$HOST_R
  "NESTED_R":$NESTED_R
  "WM_R":"$WM_R"
  "ALL_R":$ALL_R
)

# 2. Переменная часть: пройти построчно по /etc/X11/trusted:
#    из очредной строки $FILE($ROLE) выделяем и применяем
while read line; do
  LINE="$line"

  IFS='('
  set $line
  IFS=' '

  FILE=$1
  ROLE="($2"

  if [ -x $FILE ]; then
    for row in "${replacements[@]}"; do
      original="$(echo $row | cut -d: -f1)";
      new="$(echo $row | cut -d: -f2)";
      res=$(echo "$ROLE" | sed -e "s/${original}/${new}/g");
      ROLE="$res"
    done

    HEX_ROLE=$(printf "%x\n" $(eval echo "\$($ROLE)"))
    bytlen=${#HEX_ROLE}
    if [ $((bytlen%2)) -ne "0" ]; then
       HEX_ROLE="0$HEX_ROLE"
    fi

    if [ "$CLEAR" = "1" ]; then
      /usr/bin/setfattr -n security.exec_id -v 0x00 $FILE
    else
      /usr/bin/setfattr -n security.exec_id -v "0x$HEX_ROLE" $FILE
    fi
  fi
done < /etc/X11/trusted
